=== debian/changelog ===
vg (1.59.0+ds-0.1) unstable; urgency=medium

  * Non-maintainer upload

  [ Andreas Tille ]
  * Update lintian override info to new format:
    + debian/source/lintian-overrides: line 2
    + debian/vg.lintian-overrides: line 5, 8-12
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Replace dependency on transitional package libncurses5-dev
      with replacement libtinfo6, libncurses-dev.

  [ Pierre Gruet ]
  * Using tags and filenamemangle in d/watch

  [ Michael R. Crusoe ]
  * New upstream version. Closes: #1013061, #1084554
  * Added patch to deal with bashim.
  * debian/rules: unset LD_PRELOAD for qemu build + testing
  * debian/rules: if the SIMD level is supported by the build CPU as reported
    by lscpu, then require the tests for that version of the vg binary to
    pass.
  * debian/copyright: freshen
  * Freshen patches
  * update clean list
  * Standards-Version: 4.6.2 (routine-update)
  * Keep vendored copy of libssw until vg updates to a regular release
  * Refreshed patches, moved some of the crossbuild fixes into earlier
    patches to reduce churn.
  * d/patches/series: skip the ssw patches to use the code copy for now.
  * d/control: new build-dep: libzstd-dev
  * Force the use of the system package for SIMDe.
  * Added patch to fix gcc 12+ issues.
  * d/copyright: exclude the unused benchmarks.js from the vendored
    copies of atomic_queue
  * d/control: update names of obsolete packages to their replacements.
    Closes: #1043312
  * Ignore test failures

 -- Bastian Germann <bage@debian.org>  Thu, 21 Nov 2024 00:12:52 +0000
