=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=auto,repack,compression=xz,\
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
https://github.com/vgteam/vg/releases (?:.*?/)vg-?v?@ANY_VERSION@@ARCHIVE_EXT@
